using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class AngrySkellyBossController : BossController
{
    protected override bool PrimaryMovementBehaviourCheck()
    {
        return Vector3.Distance(agent.transform.position, currentTarget.transform.position) > bossMeleeAttacksRange;
    }
    protected override bool SecondHighestPriorityCheck()
    {
        return base.ThirdHighestPriorityCheck();
    }
    protected override bool ThirdHighestPriorityCheck()
    {
        return base.SecondHighestPriorityCheck();

    }


    protected override void PerformPrimaryMovementBehaviour()
    {
        base.PerformPrimaryMovementBehaviour();
    }
    protected override void PerformHighestPriorityAction()
    {
        base.PerformHighestPriorityAction();
    }

    protected override void PerformSecondHighestPriorityAction()
    {
        PerformMeleeAbility();
    }

    protected override void PerformThirdHighestPriorityAction()
    {
        PerformCoreAbility();
    }

    protected override void PerformUltimate()
    {
        Debug.Log("INSIDE CAN CAST ULTIMATE: " + bossAbilityBinder.CanCastUltimate());
        ResetValuesOnAbilityPerformed();
        bossAbilityBinder.UseUltimateAbility(currentTarget.transform);
    }

    protected override void PerformCoreAbility()
    {
        base.PerformCoreAbility();
    }

    protected override void PerformMeleeAbility()
    {
        base.PerformMeleeAbility();
    }
}
