using Photon.Pun;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class NPCProjectileSpawnLocationController : ProjectileSpawnLocationController
{
    NPCController npcController;
    NPCControllerBase npcControllerBase;

    protected override void Awake()
    {
        npcController = GetComponentInParent<NPCController>();
        photonView = GetComponentInParent<PhotonView>();
        npcControllerBase = GetComponentInParent<NPCControllerBase>();
    }


    // Update is called once per frame
    protected override void Update()
    {
        if(npcController == null)
        {
            if (npcControllerBase.currentTarget == null) return;
            targetPoint = npcControllerBase.currentTarget.transform.position;
            targetPoint.y = this.transform.position.y;
            lookAt.forward = targetPoint - lookAt.position;
        }
        else
        {
            if (npcController.currentTarget == null) return;
            targetPoint = npcController.currentTarget.transform.position;
            targetPoint.y = this.transform.position.y;
            lookAt.forward = targetPoint - lookAt.position;
        }
    }
}
