using Photon.Pun;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class NetworkAbilityChainReactionAreaOfEffectOverTime : NetworkAbilityChainReaction
{
    public AreaOfEffectOverTimeAbility areaAbility;
    public NetworkedAreaOfEffectOverTime area;

    public override void ExecuteAbilityChainReaction(PhotonView owner, Taggable ownerTag, List<Taggable> targets)
    {
        if (owner.IsMine)
        {
            spawnedChainReaction = PhotonNetwork.Instantiate("Abilities/" + abilityPrefabName.name, this.transform.position, Quaternion.identity);

            area = spawnedChainReaction.GetComponent<NetworkedAreaOfEffectOverTime>();

            SetupValues(owner, ownerTag);

            area.Init();
        }
    }

    private void SetupValues(PhotonView user, Taggable userTag)
    {
        area.owner = user;
        area.ownerTag = userTag;
        area.ability = areaAbility;
        area.radius = areaAbility.radius;
        area.telegraphDelay = areaAbility.telegraphDelay;
        area.lifeSpan = areaAbility.lifeSpan;
        area.duration = areaAbility.duration;
        area.followUser = areaAbility.followUser;
        area.followTarget = areaAbility.followTarget;
        area.damageFollowingTarget = areaAbility.damageFollowingTarget;
        area.canHitSelf = areaAbility.canHitSelf;
    }
}
