﻿using Photon.Pun;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;

public class GameEventListener_JobInstance : MonoBehaviour
{
    public GameEvent_JobInstance Event;
    public UnityEvent_JobInstance Response;

    private void OnEnable()
    {
        Event.RegisterListener(this);
    }

    private void OnDisable()
    {
        Event.UnRegisterListener(this);
    }

    public void OnEventRaised(JobInstance jobData)
    {
        Response.Invoke(jobData);
    }
}

[System.Serializable]
public class UnityEvent_JobInstance : UnityEvent<JobInstance>
{
}
