﻿using Photon.Pun;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;

public class GameEventListener_VendorData : MonoBehaviour
{
    public GameEvent_VendorData Event;
    public UnityEvent_VendorData Response;

    private void OnEnable()
    {
        Event.RegisterListener(this);
    }

    private void OnDisable()
    {
        Event.UnRegisterListener(this);
    }

    public void OnEventRaised(VendorData vendorData)
    {
        Response.Invoke(vendorData);
    }
}

[System.Serializable]
public class UnityEvent_VendorData : UnityEvent<VendorData>
{
}
