﻿using Photon.Realtime;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;

public class GameEventListener_RoomList : MonoBehaviour
{
    public GameEvent_RoomList Event;
    public UnityEvent_RoomList Response;

    private void OnEnable()
    {
        Event.RegisterListener(this);
    }

    private void OnDisable()
    {
        Event.UnRegisterListener(this);
    }

    public void OnEventRaised(List<RoomInfo> roomList)
    {
        Response.Invoke(roomList);
    }
}

[System.Serializable]
public class UnityEvent_RoomList : UnityEvent<List<RoomInfo>>
{
}
